/*===========================================================================*
 *  Header file for Atom Config File
 *  Project            : AtomCraftWork_samples
 *  Tool Ver.          : Ver.3.55.00
 *  ACF  Ver.          : Ver.1.37.0
 *  File Name          : ADX2_samples_acf.h
 *  File Size          : 6880 bytes
 *  Target             : Public
 *  Categories         : 3
 *  AISAC Controls     : 16
 *  Global AISACs      : 0
 *  Voice Limit Groups : 1
 *  DSP BUS Settings   : 1
 *  DSP BUS Settings Snapshot  : 0
 *  DSP BUS Name       : 9
 *  Game Variables     : 1
 *  Selectors          : 0
 *  REACTs             : 1
 *  Output Ports  : 1
 *  Project Comment    : 
 *===========================================================================*/

#define CRI_ADX2_SAMPLES_ACF_NUM_CATEGORIES_PER_PLAYBACK (4)
#define CRI_ADX2_SAMPLES_ACF_CATEGORYNUM (3)
#define CRI_ADX2_SAMPLES_ACF_AISACCONTROLNUM (16)
#define CRI_ADX2_SAMPLES_ACF_GLOBALAISACNUM (0)
#define CRI_ADX2_SAMPLES_ACF_VOICELIMITGROUPNUM (1)
#define CRI_ADX2_SAMPLES_ACF_DSPSETTINGNUM (1)
#define CRI_ADX2_SAMPLES_ACF_DSPSETTINGSNAPSHOTNUM (0)
#define CRI_ADX2_SAMPLES_ACF_DSPBUSNAMENUM (9)
#define CRI_ADX2_SAMPLES_ACF_GAMEVARIABLENUM (1)
#define CRI_ADX2_SAMPLES_ACF_SELECTORNUM (0)
#define CRI_ADX2_SAMPLES_ACF_REACTNUM (1)
#define CRI_ADX2_SAMPLES_ACF_OUTPUTPORTNUM (1)

/* Category List (Category ID) */
#define CRI_ADX2_SAMPLES_ACF_CATEGORY_MUSIC                ( 0) /*  */
#define CRI_ADX2_SAMPLES_ACF_CATEGORY_VOICE                ( 1) /*  */
#define CRI_ADX2_SAMPLES_ACF_CATEGORY_SE                   ( 2) /*  */

/* AISAC Control List (AISAC Control ID) */
#define CRI_ADX2_SAMPLES_ACF_AISACCONTROL_ANY                  ( 0) /*  */
#define CRI_ADX2_SAMPLES_ACF_AISACCONTROL_DISTANCE             ( 1) /*  */
#define CRI_ADX2_SAMPLES_ACF_AISACCONTROL_AISACCONTROL02       ( 2) /*  */
#define CRI_ADX2_SAMPLES_ACF_AISACCONTROL_AISACCONTROL03       ( 3) /*  */
#define CRI_ADX2_SAMPLES_ACF_AISACCONTROL_AISACCONTROL04       ( 4) /*  */
#define CRI_ADX2_SAMPLES_ACF_AISACCONTROL_AISACCONTROL05       ( 5) /*  */
#define CRI_ADX2_SAMPLES_ACF_AISACCONTROL_AISACCONTROL06       ( 6) /*  */
#define CRI_ADX2_SAMPLES_ACF_AISACCONTROL_AISACCONTROL07       ( 7) /*  */
#define CRI_ADX2_SAMPLES_ACF_AISACCONTROL_AISACCONTROL08       ( 8) /*  */
#define CRI_ADX2_SAMPLES_ACF_AISACCONTROL_AISACCONTROL09       ( 9) /*  */
#define CRI_ADX2_SAMPLES_ACF_AISACCONTROL_AISACCONTROL10       (10) /*  */
#define CRI_ADX2_SAMPLES_ACF_AISACCONTROL_AISACCONTROL11       (11) /*  */
#define CRI_ADX2_SAMPLES_ACF_AISACCONTROL_AISACCONTROL12       (12) /*  */
#define CRI_ADX2_SAMPLES_ACF_AISACCONTROL_AISACCONTROL13       (13) /*  */
#define CRI_ADX2_SAMPLES_ACF_AISACCONTROL_AISACCONTROL14       (14) /*  */
#define CRI_ADX2_SAMPLES_ACF_AISACCONTROL_AISACCONTROL15       (15) /*  */

/* Voice Limit Group (Voice Limit Group Index) */
#define CRI_ADX2_SAMPLES_ACF_VOICELIMITGROUP_VOICELIMITGROUP_0    ( 0) /*  */

/* DspSetting List (DspSetting Name) */
#define CRI_ADX2_SAMPLES_ACF_DSPSETTING_DSPBUSSETTING_0      "DspBusSetting_0" /*  */

/* DspBusName List (DspBus Name) */
#define CRI_ADX2_SAMPLES_ACF_DSPBUSNAME_BUS1                 "BUS1" /*  */
#define CRI_ADX2_SAMPLES_ACF_DSPBUSNAME_BUS2                 "BUS2" /*  */
#define CRI_ADX2_SAMPLES_ACF_DSPBUSNAME_BUS3                 "BUS3" /*  */
#define CRI_ADX2_SAMPLES_ACF_DSPBUSNAME_BUS4                 "BUS4" /*  */
#define CRI_ADX2_SAMPLES_ACF_DSPBUSNAME_BUS5                 "BUS5" /*  */
#define CRI_ADX2_SAMPLES_ACF_DSPBUSNAME_BUS6                 "BUS6" /*  */
#define CRI_ADX2_SAMPLES_ACF_DSPBUSNAME_BUS7                 "BUS7" /*  */
#define CRI_ADX2_SAMPLES_ACF_DSPBUSNAME_MASTEROUT            "MasterOut" /*  */
#define CRI_ADX2_SAMPLES_ACF_DSPBUSNAME__OBJECT_BASED_AUDIO  "_object_based_audio" /*  */

/* Game Variable (Game Variable Name) */
#define CRI_ADX2_SAMPLES_ACF_GAMEVARIABLE_DEFAULT              "Default " /*  */

/* Output Port (Output Port Name) */
#define CRI_ADX2_SAMPLES_ACF_OUTPUTPORT__OBJECT_BASED_AUDIO  "_object_based_audio" /*  */

